//
// Vertex shader for billboard
//
// Author: Byungil Jeong
//

varying bool  showContents;

uniform vec3  lightPos;
varying vec3  normal, ecLightPos, ecVertexPos;

void main(void)
{
	// need absolute value of x, y and z component to classify surfaces
	vec3 absNormal  = abs(gl_Normal.xyz);
	float xzLen = length(absNormal.xz);
	 
	// classifying surfaces
	if (xzLen > absNormal.y)
		showContents = true;
	else
		showContents = false;

	// pass texture coordinate to fragment shader
	// to be interpolated properly
	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_Position = ftransform();
	
	normal = normalize(gl_NormalMatrix * gl_Normal);
	vec4 ecVertex = gl_ModelViewMatrix * gl_Vertex;
	vec4 ecLight = gl_ModelViewMatrix * vec4(lightPos, 1.0);
	ecLightPos = ecLight.xyz;
	ecVertexPos = ecVertex.xyz;
}
